#!/usr/bin/env Rscript

dat=read.table("spacers", header=FALSE, as.is=TRUE)

args<-commandArgs(TRUE)

#initialize variables
CN_cnt = as.numeric(args[[1]])
CN_size = as.numeric(args[[2]])
CN_mean = as.numeric(args[[3]])

#CN_cnt = 20
#CN_size = 5000000
#CN_mean = 2.5

bounds = matrix(0, CN_cnt, 4)

#Select, at random, 'CN_cnt' spacer regions from previous analysis
shuf = dat[sample(nrow(dat), nrow(dat)),]
dif = shuf[,3] - shuf[,2]
spacers=head(shuf[which(dif > 400000),], CN_cnt)

#Generate integer CN value for each segment from poisson distribution
CN = rpois(1000, CN_mean)
CN = head(CN[which(CN != 2)], CN_cnt)

step = 0

for (i in 1:CN_cnt) {

  step = step + 1

  l = spacers[i,3]-spacers[i,2]

  #Generate length of CN segment from exponential distribution
  size = 999999999
  while (size > l) {
    size = round(rexp(100,1/CN_size))
    size = head(size[which(size>200000 & size<20000000)], 1)
  }

  #Generate spacing between CN segment and flanking regions from uniform random distribution
  space = runif(2,0,1)
  space = floor( (l-size)*space/sum(space) )[1]

  pos = spacers[i,2] + space
  bounds[step,] = c(spacers[i,1], pos, pos + size, CN[i])

}

#spacers
#bounds

write.table(bounds, file=paste("out"), row.names=FALSE, col.names=FALSE, quote=FALSE, sep="\t")

